import processing.core.*; import pitaru.sonia_v2_9.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class particules_balles_04 extends PApplet {//
 // commande cr\u00e9\u00e9e automatiquement lorsqu'on importe Sonia avec Processing

Balle b;   //d\u00e9claration d'un objet de type Balle
Balle b2;  //d\u00e9claration d'un autre objet de type Balle
Balle b3;  //d\u00e9claration d'un autre objet de type Balle

public void setup()
{
  size ( 400, 200 ); // D\u00e9finir la taille de la fen\u00eatre.
  background ( 255, 255, 255 );  // D\u00e9finir la couleur de fond.
  smooth();  // Lissage des formes, anti-alias.
  framerate (50);  // D\u00e9finir le nombre de frame par seconde
  Sonia.start(this); // Lancer Sonia.

  // Cr\u00e9er des objets Balle. Les valeurs d\u00e9finissent les attributs initialis\u00e9s dans la class Balle.
  b = new Balle (200, 50.0f, 20.0f, color (255, 0, 0, 100), random (15, 20) );
  b2 = new Balle (200.0f, 100.0f, 20.0f, color (0, 255,  0, 100) , random (20, 25) );
  b3 = new Balle (200.0f, 150.0f, 20.0f, color (0, 0,  255, 100) , random (25, 30) );

  // Afficher les objets balles
}
public void draw ()
{
  background ( 255, 255, 255 ); // D\u00e9finir la couleur de fond.
  {
    if (mousePressed == true) // si la souris est cliqu\u00e9e, chaque balle se comporte selon les propri\u00e9t\u00e9s appel\u00e9es (ici, affichage et mouvement).
    {
      b.affichage();
      b.mouvement();
      b2.affichage();
      b2.mouvement();
      b3.affichage();
      b3.mouvement();
    }
    else // Sinon, revenir \u00e0 la propri\u00e9t\u00e9 d\u00e9finie par positionInitiale.
    {
      b.positionInitiale();
      b2.positionInitiale();
      b3.positionInitiale();
    }
  }
}


//

class Balle
{
  // attributs:

  float x;  // Position en x.
  float y;  // Position en y.
  int c;  // Couleur.
  float r;  // Rayon.
  float v;  // Vitesse.
  Sample mySample1;  // Son.

  // Constructeur:
  // C'est selon ces coordonn\u00e9es qu'une valeur sera affect\u00e9e \u00e0 chaque attribut lorsqu'un objet Balle sera cr\u00e9\u00e9 dans le setup.
  Balle( float initX, float initY, float initR, int initC, float initV )
  {
    x = initX;
    y = initY;
    r = initR;
    c = initC;
    v = initV;
    mySample1 = new Sample("bip01.aif");  //  L'attribut son est d'embl\u00e9e d\u00e9fini: chaque objet Balle produira le m\u00eame son.
  }

  // Propri\u00e9t\u00e9s:

  public void affichage()
  {
    fill (c);  // La couleur prendra la valeur d\u00e9finie dans l'objet Balle cr\u00e9\u00e9 dans le set up.
    stroke (c); // Le bord prendra la valeur de couleur d\u00e9finie dans l'objet Balle cr\u00e9\u00e9 dans le set up.
    ellipse (x, y, 2*r, 2*r );  // Il s'agit ici d'une ellipse d\u00e9finie sous forme de cercle.
  }

      public void positionInitiale()
  {
    fill (c);  // La couleur prendra la valeur d\u00e9finie dans l'objet Balle cr\u00e9\u00e9 dans le set up.
    stroke (c);  // Le bord prendra la valeur de couleur d\u00e9finie dans l'objet Balle cr\u00e9\u00e9 dans le set up.
    ellipse(x = width/2, y, 2*r, 2*r ); // Il s'agit ici d'une ellipse d\u00e9finie sous forme de cercle.
  }

  public void mouvement()
  {
    x = x + v; // Ajouter v (vitesse) \u00e0 la valeur de x: mettre en mouvement selon les conditions suivantes.
    if ( x >= width ) // Si x est plus grand ou \u00e9gal \u00e0 la largeur: lorsque la balle cogne le bord droit de la fen\u00eatre.
    {
      v = -v; // La vitesse initialement positive prend une valeur n\u00e9gative: la balle "avance en arri\u00e8re".
      mySample1.play(); // Le son d\u00e9fini dans le constructeur est jou\u00e9.
      mySample1.setPan(1);  // Le pan (panorama, position du son dans la st\u00e9r\u00e9o) est \u00e0 gauche. (-1 = gauche, 0 = centre, 1 = droite)
    }
    else if ( x <= 0 ) // Si x est plus petit ou \u00e9gal \u00e0 0: lorsque la balle cogne le bord gauche de la fen\u00eatre.
    {
      v = -v; // La vitesse prend \u00e0 nouveau une valeur n\u00e9gative: la balle recule.
      mySample1.play(); // Le son d\u00e9fini dans le constructeur est jou\u00e9.
      mySample1.setPan(-1); // Le pan (panorama, position du son dans la st\u00e9r\u00e9o) est \u00e0 gauche. (-1 = gauche, 0 = centre, 1 = droite)
    }
  }
}
}